import greenfoot.*;

/**
 * This game of Flower Gatherer is action-packed. A pelican is controlled by the user that collects flowers
 * that appear and disappear. Each flower collected is worth one point. The user will use the arrow keys to
 * control the direction in which the pelican is going. The pelican can collect multiple flowers at once.
 * 
 * My enhancement is that the Flower Gatherer will sprint when the space bar is pressed, as the speed will
 * be increased by 5. The user can simultaneously use the arrow keys to control the direction of the sprint.
 * This allows the user to collect flowers that are about to disappear. However, the feature cannot be used
 * forever. Rather, after a short sprint, the pelican will slow down and rest for a little bit before being
 * able to sprint again.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FlowerGatherer extends Actor
{
    private int stepCounter; 
    private int speed;
    private boolean spaceEnabled = true;
    private int countdown = 100;
    private int countFalse = 400;
    
    /**
     * Act - do whatever the FlowerGatherer wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        stepCounter++;
        
        if(Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("d") == true)
        {
            this.setImage("pelican.png");
            this.setRotation(0);
            this.move(speed);
            //System.out.println("Key pressed");
        }    
        else if (Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("a") == true)
        {
            this.setImage("pelicanleft.png");
            this.setRotation(180);
            this.move(speed);
      
        }
        else if (Greenfoot.isKeyDown("up") || Greenfoot.isKeyDown("w") == true)
        {
            this.setImage("pelicanleft.png");
            this.setRotation(270);
            this.move(speed);
      
        }
        else if (Greenfoot.isKeyDown("down") || Greenfoot.isKeyDown("s") == true)
        {
            this.setImage("pelicanleft.png");
            this.setRotation(90);
            this.move(speed);
      
        }
        
        
        if (Greenfoot.isKeyDown("space") == true && spaceEnabled == true)   
        {
            countdown = countdown - 5;
            this.move(speed+5);
            
        }
       
        if (countdown < 0)
        {
            spaceEnabled = false;
            
            
            countFalse = countFalse - 5;
        }
        
        if (countFalse <0)
        {
            spaceEnabled = true;
            countdown = 100;
            countFalse = 400;
        }
        
        this.getFlower();
        if (stepCounter%20 == 0)
        {    
            this.growFlower();
        }
        //System.out.println(stepCounter);
    }
    private int score;
     /**
     * Default Constructor. This creates a generic FlowerGatherer
     */
    public FlowerGatherer()
    {
       score = 0;
       stepCounter = 0;
       speed = 7;
    }
    
    /**
     * Act - do whatever the FlowerGatherer whats to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void getFlower()
    {
        if(this.isTouching(Flower.class) == true)
        {
            this.removeTouching(Flower.class);
            score = score + 1;
            System.out.println("Score: "+this.score);
        }
    }
    
    public void growFlower()
    {
        int randX = Greenfoot.getRandomNumber(600);
        int randY = Greenfoot.getRandomNumber(400);
        World w = this.getWorld();//stores the current world in a variable called w
        Flower f = new Flower();
        w.addObject(f,randX,randY);
        //System.out.println(randX);
    }
}



